import Koa from "koa";
import _locreq from "locreq";
import { resolve } from "path";
import Static from "koa-static";
import Router from "@koa/router";
import mount from "koa-mount";
const locreq = _locreq(__dirname);
import Sealious, { App, Collection, FieldTypes, Policies } from "sealious";

declare module "koa" {
	interface BaseContext {
		$context: Sealious.Context;
		$app: Sealious.App;
		$body: Record<string, unknown>;
	}
}
const app = new (class extends App {
	config = {
		upload_path: locreq.resolve("uploaded_files"),
		datastore_mongo: {
			host: "localhost",
			port: 20723,
			db_name: "sealious-playground",
		},
		email: {
			from_address: "zglszanskoweb@example.com",
			from_name: "Zgłaszańsko web",
		},
	};
	manifest = {
		name: "Zgłaszańsko web",
		logo: resolve(__dirname, "../assets/logo.png"),
		version: "0.0.1",
		default_language: "pl",
		base_url: "localhost:8080",
		admin_email: "admin@example.com",
		colors: {
			primary: "#5294a1",
		},
	};
	collections = {
		...App.BaseCollections,
	};
})();

app.HTTPServer.addStaticRoute("/", locreq.resolve("public"));
const port = 8080;

console.log(`Listening on 127.0.0.1:${port}`);
app.start();
